
function highlightKeywords(element,keyword) {

  if (element) {
    if (element.nodeType == 3) {        // Text node
      while (true) {
        var value = element.nodeValue;  // Search for keyword in text node
        var idx = value.toLowerCase().indexOf(keyword);

        if (idx < 0) break;             // not found, abort

        var span = document.createElement("span");
        var text = document.createTextNode(value.substr(idx,keyword.length));
        span.appendChild(text);
        span.setAttribute("class","highlightKeywords");
        span.style.color="#0099ff";
        text = document.createTextNode(value.substr(idx+keyword.length));
        element.deleteData(idx, value.length - idx);
        if (element.parentNode.lastChild==element) {
                    element.parentNode.appendChild(span);
                    element.parentNode.appendChild(text);
                }else{
                    var next = element.nextSibling;
                element.parentNode.insertBefore(span, next);
                element.parentNode.insertBefore(text, next);
                }
        element = text;
      }
    } else if (element.nodeType == 1) { // Element node
      if (element.style.display != "none" && element.nodeName.toLowerCase() != 'select') {
        
        var childElement=element.childNodes[0];
        while(childElement){
            if (!childElement.className || childElement.className.indexOf("highlightKeywords")==-1) {
                highlightKeywords(childElement,keyword);
            }
            childElement=childElement.nextSibling;
        }
      }
      

    }
  }
}

function highlightKeywordsArray(element,keywordsStr){
    var keywords=eval(keywordsStr);
    for(var i=0;i<keywords.length;i++){
       highlightKeywords(element,keywords[i]);
    }
}


// We're using a global variable to store the number of occurrences
var searchCount = 0;
var currentSearchNum = -1;
var offsetHeight=0;
function reset() {
    searchCount = 0;
    currentSearchNum = -1;
}


// helper function, recursively searches in elements and their child nodes
function highlightSearchWrods(element,keyword) {
    if (element) {
        if (element.nodeType == 3) {        // Text node
            while (true) {
                var value = element.nodeValue;  // Search for keyword in text node
                var idx = value.toLowerCase().indexOf(keyword);

                if (idx < 0) break;             // not found, abort
                var span = document.createElement("span");
                var text = document.createTextNode(value.substr(idx,keyword.length));
                span.appendChild(text);
                span.id="highlightSearchWrods"+searchCount;
                span.style.backgroundColor="yellow";
                span.style.color="black";
                text = document.createTextNode(value.substr(idx+keyword.length));
                element.deleteData(idx, value.length - idx);
                if (element.parentNode.lastChild==element) {
                    element.parentNode.appendChild(span);
                    element.parentNode.appendChild(text);
                }else{
                    var next = element.nextSibling;
                    element.parentNode.insertBefore(span, next);
                    element.parentNode.insertBefore(text, next);
                }
                
                element = text;
                searchCount++;  // update the counter
            }
        } else if (element.nodeType == 1) { // Element node
            if (element.style.display != "none" && element.nodeName.toLowerCase() != 'select') {
                var childElement=element.childNodes[0];
                    while(childElement){
                        if (!childElement.id || childElement.id.indexOf("highlightSearchWrods")==-1) {
                            highlightSearchWrods(childElement,keyword); 
                        }
                        childElement=childElement.nextSibling;
                    }

            }
        }
    }
   
}

function scrollToSearchIndex(index){
    if(currentSearchNum>=0 && currentSearchNum<searchCount){
   var element= document.getElementById("highlightSearchWrods"+index);
        element.style.backgroundColor="orange";
//         document.getElementById("highlightSearchWrods"+index).scrollIntoView();
        getPosition(element);
    }

}

function getPosition(e) {
    var t = e.offsetTop;
    var l = e.offsetLeft;
    var w = e.offsetWidth;
    var h = e.offsetHeight - 1;
    while (e = e.offsetParent) {
        t += e.offsetTop;
        l += e.offsetLeft;
    }
    scrollTo(l, t+ offsetHeight);
//    e.scrollIntoView();
}

function setPaddingHeight(height){
    offsetHeight=height;
}

// helper function, recursively removes the highlights in elements and their childs
function clearHighlightSearchWrods(element) {
    if (element) {
        if (element.nodeType == 1) {
            if (element.id && element.id.indexOf("highlightSearchWrods")!=-1) {
                var text = element.removeChild(element.firstChild);
                element.parentNode.insertBefore(text,element);
                element.parentNode.removeChild(element);
                element=text;
                clearHighlightSearchWrods(element.parentNode);
                return true;
            } else {
                var childElement=element.childNodes[0];
                while(childElement){
                    if (clearHighlightSearchWrods(childElement)) {
                        element.normalize();
                    }
                    childElement=childElement.nextSibling;
                }

            }
        }
    }
    return false;
}

function scrollToNext(){
    if (currentSearchNum>=0) {
        document.getElementById("highlightSearchWrods"+currentSearchNum).style.backgroundColor="yellow";
    }  
    currentSearchNum++; 
    if(currentSearchNum>searchCount-1){
        currentSearchNum=0;
    }

    scrollToSearchIndex(currentSearchNum);
}

function scrollToPre(){
    document.getElementById("highlightSearchWrods"+currentSearchNum).style.backgroundColor="yellow";
     currentSearchNum--;
     if(currentSearchNum<0){
        currentSearchNum=searchCount-1;
    }
      scrollToSearchIndex(currentSearchNum);
}

function searchNewWrods(keyword){
    reset();
    clearHighlightSearchWrods(document.body);
    highlightSearchWrods(document.body,keyword);
    scrollToNext();
}



