// We're using a global variable to store the number of occurrences
var MyApp_SearchResultCount = 0;
var keywordBox = new Array();
var offset = 0;

function reset() {
    MyApp_SearchResultCount = 0;
    keywordBox = new Array();
}

// helper function, recursively searches in elements and their child nodes
function MyApp_HighlightAllOccurencesOfStringForElement(element,keyword) {
    if (element) {
        if (element.nodeType == 3) {        // Text node
            while (true) {
                var value = element.nodeValue;  // Search for keyword in text node 设置或返回元素值。
                var idx = value.toLowerCase().indexOf(keyword);

                if (idx < 0) break;             // not found, abort
                var span = document.createElement("span");//创建元素
                var text = document.createTextNode(value.substr(idx,keyword.length));//创建文本节点
                span.appendChild(text);
                span.setAttribute("class","MyAppHighlight");
                span.style.backgroundColor="yellow";
                span.style.color="black";
                text = document.createTextNode(value.substr(idx+keyword.length));

                element.deleteData(idx, value.length - idx);
                var next = element.nextSibling;//返回位于相同节点树层级的下一个节点。
                element.parentNode.insertBefore(span, next);//返回元素的父节点
                element.parentNode.insertBefore(text, next);
                element = text;
                if(span.offsetTop == 0){
                    return;
                }
                keywordBox.push(span);
                MyApp_SearchResultCount++;// update the counter
            }
        } else if (element.nodeType == 1) { // Element node
            if (element.style.display != "none" && element.nodeName.toLowerCase() != 'select') {
                var originalChildNodes = [];
                for (i=0, len= element.childNodes.length-1; i <= len; i++) {
                    originalChildNodes.push(element.childNodes[i]);
                }
                var i, len;
                for (i=0, len= originalChildNodes.length-1; i <= len; i++) {
                    MyApp_HighlightAllOccurencesOfStringForElement(originalChildNodes[i],keyword);
                }
            }
        }
    }
}

//blue the keywords 2
function MyApp_blue(element,keyword) {

    if (element) {
        if (element.nodeType == 3) {        // Text node
            while (true) {
                var value = element.nodeValue;  // Search for keyword in text node
                var idx = value.toLowerCase().indexOf(keyword);
                if (idx < 0) break;             // not found, abort
                var span = document.createElement("span");//创建元素
                var text = document.createTextNode(value.substr(idx,keyword.length));//创建文本节点
                span.appendChild(text);
                span.setAttribute("class","bluehighlight");
                span.style.color="#0099ff";
                text = document.createTextNode(value.substr(idx+keyword.length));
                element.deleteData(idx, value.length - idx);
                var next = element.nextSibling;//返回位于相同节点树层级的下一个节点。
                element.parentNode.insertBefore(span, next);//返回元素的父节点
                element.parentNode.insertBefore(text, next);
                element = text;
                if(span.offsetTop == 0){
                    return;
                }
                MyApp_SearchResultCount++;// update the counter
            }
        } else if (element.nodeType == 1) { // Element node
            if (element.style.display != "none" && element.nodeName.toLowerCase() != 'select') {
                var originalChildNodes = [];
                for (i=0, len= element.childNodes.length-1; i <= len; i++) {
                    originalChildNodes.push(element.childNodes[i]);
                }
                var i, len;
                for (i=0, len= originalChildNodes.length-1; i <= len; i++) {
                    MyApp_blue(originalChildNodes[i],keyword);
                }
            }
        }
    }
}

//blue the keywords 1
function MyAPP_HighlightBlueKeyword(keyword){
    
    MyApp_blue(document.body, keyword.toLowerCase());
}

// the main entry point to start the search
function MyApp_HighlightAllOccurencesOfString(keyword) {
    MyApp_RemoveAllHighlights();
    MyApp_HighlightAllOccurencesOfStringForElement(document.body, keyword.toLowerCase());
}

// helper function, recursively removes the highlights in elements and their childs
function MyApp_RemoveAllHighlightsForElement(element) {
    if (element) {
        if (element.nodeType == 1) {
            if (element.getAttribute("class") == "MyAppHighlight") {
                var text = element.removeChild(element.firstChild);
                element.parentNode.insertBefore(text,element);
                element.parentNode.removeChild(element);
                return true;
            } else {
                var normalize = false;
                for (var i=element.childNodes.length-1; i>=0; i--) {
                    if (MyApp_RemoveAllHighlightsForElement(element.childNodes[i])) {
                        normalize = true;
                    }
                }
                if (normalize) {
                    element.normalize();
                }
            }
        }
    }
    return false;
}

function MyApp_RemoveBlue() {
    MyApp_RemoveAllBlue(document.body);
}

// helper function, recursively removes the highlights in elements and their childs
function MyApp_RemoveAllBlue(element) {
    if (element) {
        if (element.nodeType == 1) {
            if (element.getAttribute("class") == "bluehighlight") {
                var text = element.removeChild(element.firstChild);
                element.parentNode.insertBefore(text,element);
                element.parentNode.removeChild(element);
                return true;
            } else {
                var normalize = false;
                for (var i=element.childNodes.length-1; i>=0; i--) {
                    if (MyApp_RemoveAllBlue(element.childNodes[i])) {
                        normalize = true;
                    }
                }
                if (normalize) {
                    element.normalize();
                }
            }
        }
    }
    return false;
}


// the main entry point to remove the highlights
function MyApp_RemoveAllHighlights() {
    MyApp_SearchResultCount = 0;
    keywordBox = new Array();
    MyApp_RemoveAllHighlightsForElement(document.body);
}


function getPosition(e) {
    var t = e.offsetTop;
    var l = e.offsetLeft;
    var w = e.offsetWidth;
    var h = e.offsetHeight - 1;
    while (e = e.offsetParent) {
        t += e.offsetTop;
        l += e.offsetLeft;
    }
    scrollTo(l, t+offset);
//    e.scrollIntoView();

}

function gotoNext(currentIndex, nextIndex,offSet) {
    offset = parseInt(offSet);
    if (currentIndex >= 0) {
        keywordBox[currentIndex].style.backgroundColor = 'yellow';
    }
    keywordBox[nextIndex].style.backgroundColor = 'orange';
    getPosition(keywordBox[nextIndex]);
}

function setOffSet(offSet){
    offset = offSet;
}

//setting maximum-scale
function increaseMaxZoomFactor() {
    
    var element = document.createElement_x('meta');
    element.name = "viewport";
    element.content = "user-scalable=yes,maximum-scale=10";
    var head = document.getElementsByTagName_r('head')[0];
    head.appendChild(element);
    
}